// -------------------------------------------------------------------------------
// 
// 		cwCu		TEhf[^ϊvOwb_t@C
// 
// 				Ver 3.12c
// 
// -------------------------------------------------------------------------------

#ifndef __DXSOUNDCONVERT_H__
#define __DXSOUNDCONVERT_H__

// CN[h ------------------------------------------------------------------

#include "DxCompileConfig.h"
#ifndef DX_NON_ACM
#ifndef DX_GCC_COMPILE
	#include <mmreg.h>
#endif	
	#include <msacm.h>
#endif
#include "DxLib.h"
#include "DxUseCStrmBaseFilter.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` --------------------------------------------------------------------

// \̒` --------------------------------------------------------------------

// RIFF`Nf[^
struct ___RIFFCHUNK
{
	DWORD						fcc ;
	DWORD						 cb ;
} ;

// ^Cv
#define SOUND_METHODTYPE_NORMAL				(0)		// ʏ̏(ʂȏ͋܂Ȃ)
#define SOUND_METHODTYPE_ACM				(1)		// `blgp
#define SOUND_METHODTYPE_OGG				(2)		// nffgp
#define SOUND_METHODTYPE_DSMP3				(3)		// crgploRĐ

// v`udf[^ϊp\
struct SOUNDCONV_WAVE
{
	BYTE						*SrcBuffer ;		// ϊ̃f[^
	DWORD						SrcBufferSize ;		// ϊobt@̃f[^TCY
	DWORD						SrcSampleNum ;		// ϊobt@̃Tv
	WAVEFORMATEX				SrcFormat ;			// ϊobt@̃tH[}bg
} ;

#ifndef DX_NON_ACM

// #ifdef DX_GCC_COMPILE
struct D_HACMSTREAM__
{
	int unused ;
} ;

typedef struct D_HACMSTREAM__ *D_HACMSTREAM ;
typedef        D_HACMSTREAM   *D_LPHACMSTREAM ;

struct D_HACMOBJ__
{
	int unused ;
} ;
typedef struct D_HACMOBJ__     *D_HACMOBJ ;

typedef struct D_wavefilter_tag
{
	DWORD   cbStruct;           /* Size of the filter in bytes */
	DWORD   dwFilterTag;        /* filter type */
	DWORD   fdwFilter;          /* Flags for the filter (Universal Dfns) */
	DWORD   dwReserved[5];      /* Reserved for system use */
} D_WAVEFILTER;
typedef D_WAVEFILTER FAR  *D_LPWAVEFILTER;

#define D_MPEGLAYER3_WFX_EXTRA_BYTES			12
#define D_WAVE_FORMAT_MPEGLAYER3				0x0055 /* ISO/MPEG Layer3 Format Tag */

#define D_MPEGLAYER3_ID_UNKNOWN					0
#define D_MPEGLAYER3_ID_MPEG					1
#define D_MPEGLAYER3_ID_CONSTANTFRAMESIZE		2

typedef struct D_mpeglayer3waveformat_tag
{
	WAVEFORMATEX  wfx;
	WORD          wID;
	DWORD         fdwFlags;
	WORD          nBlockSize;
	WORD          nFramesPerBlock;
	WORD          nCodecDelay;
} D_MPEGLAYER3WAVEFORMAT ;

#define D_ACM_STREAMSIZEF_SOURCE				0x00000000L
#define D_ACM_STREAMSIZEF_DESTINATION			0x00000001L
#define D_ACM_STREAMSIZEF_QUERYMASK				0x0000000FL

#define D_ACM_METRIC_MAX_SIZE_FORMAT			50

#define D_ACM_STREAMCONVERTF_BLOCKALIGN			0x00000004
#define D_ACM_STREAMCONVERTF_START				0x00000010
#define D_ACM_STREAMCONVERTF_END				0x00000020

#ifdef  _WIN64
#define D__DRVRESERVED    15
#else
#define D__DRVRESERVED    10
#endif  // _WIN64

typedef struct D_tACMSTREAMHEADER
{
    DWORD           cbStruct;               // sizeof(D_ACMSTREAMHEADER)
    DWORD           fdwStatus;              // ACMSTREAMHEADER_STATUSF_*
    DWORD_PTR       dwUser;                 // user instance data for hdr
    LPBYTE          pbSrc;
    DWORD           cbSrcLength;
    DWORD           cbSrcLengthUsed;
    DWORD_PTR       dwSrcUser;              // user instance data for src
    LPBYTE          pbDst;
    DWORD           cbDstLength;
    DWORD           cbDstLengthUsed;
    DWORD_PTR       dwDstUser;              // user instance data for dst
    DWORD           dwReservedDriver[D__DRVRESERVED];   // driver reserved work space

} D_ACMSTREAMHEADER, *D_PACMSTREAMHEADER, FAR *D_LPACMSTREAMHEADER;
// #endif

// `blf[^ϊp\
struct SOUNDCONV_ACM
{
	WAVEFORMATEX				*Format ;				// ϊ̃tH[}bg
	D_HACMSTREAM				AcmStreamHandle[2]	;	// kꂽf[^ۂɎg`bl̃nh

	void						*SrcData ;				// ϊ̃f[^ꎞIɕۑĂ̈
	int							SrcDataSize ;			// ϊ̃f[^ꎞIɕۑĂ̈̃TCY
//	int							SrcDataValidSize ;		// ϊ̃f[^̗LȃTCY
	int							SrcDataPosition ;		// ϊ̃f[^̕ϊTCY
	int							DestDataSampleNum ;		// ϊ̃f[^̃Tv( -1:ȊȌꍇ̂ݗL )

	int							BeginSeekCompSrcSize ;	// V[N\ʒu܂ŃTuACMnhŕϊĂŁAɕϊĂ鈳kf[^̃TCY
	int							BeginSeekPosition ;		// V[N\ʒu܂ŃTuACMnhŕϊĂŁAɕϊĂWJf[^̃TCY(V[N\ʒu SOUNDCONV ֐ SeekLockPosition o[)
	void						*BeginSeekBuffer ;		// V[N\ʒu܂ŃTuACMnhŕϊĂŎgpobt@
} ;

#endif

#ifndef DX_NON_MOVIE
#ifndef DX_NON_DSHOW_MOVIE

// crgloRf[^ϊŎgpobt@NX
class SOUNDCONV_DSMP3_BUF : public D_ISampleGrabberCB
{
public :
	struct SOUNDCONV			*SoundConvData ;		// f[^ϊp\̂ւ̃|C^

	ULONG __stdcall				AddRef() ;
	ULONG __stdcall				Release() ;

	HRESULT __stdcall			QueryInterface( REFIID riid, void ** ppv ) ;
	HRESULT __stdcall			SampleCB( double SampleTime, D_IMediaSample *pSample ) ;
	HRESULT __stdcall			BufferCB( double SampleTime, BYTE *pBuffer, long BufferLen ) ;
} ;

// crgloRf[^ϊp\
struct SOUNDCONV_DSMP3
{
	void						*PCMBuffer ;			// oblɕϊꂽf[^i[郁̈
	DWORD						PCMBufferSize ;			// oblobt@̃TCY
	DWORD						PCMValidDataSize ;		// LȂobl̃TCY
	DWORD						PCMDestCopySize ;		// {obt@ւ̃Rs[TCY
} ;

#endif  // DX_NON_DSHOW_MOVIE
#endif	// DX_NON_MOVIE

// f[^ϊp\
struct SOUNDCONV
{
	int							InitializeFlag ;		// ĂꍇɗtO
	int							EndFlag ;				// ϊI痧tO
	
	int 						MethodType ;			// ^Cv( SOUND_METHODTYPE_NORMAL  )
	STREAMDATA 					Stream ;				// f[^ǂݍݗpXg[f[^

	int							HeaderPos ;				// wb_̂ʒu
	int							HeaderSize ;			// wb_̃TCY
	int							DataPos ;				// f[^̂ʒu
	int							DataSize ;				// f[^̃TCY

	WAVEFORMATEX				OutFormat ;				// ϊ̃tH[}bg

	char						ConvFunctionBuffer[ 1024 ] ;	// MethodType ʃf[^ۑpobt@̈

	void						*DestData ;				// ϊ̃f[^ꎞIɕۑ郁̈
	int							DestDataSize ;			// ϊ̃f[^ꎞIɕۑ郁̈̃TCY
	int							DestDataValidSize ;		// ϊ̃f[^̗LȃTCY
	int							DestDataCompSize ;		// ϊ̃f[^ꎞIɕۑ郁̈撆̓]ς݂̃TCY
	int							DestDataCompSizeAll ;	// ϊJn猻݂Ɏ܂łɓ]f[^̃TCY

	int							SeekLockPosition ;		// \V[Nʒu(`bl^CvŃ[vꍇׂ̈̃f[^)
#ifndef DX_NON_OGGVORBIS
	int							OggVorbisBitDepth ;			// nugp̃rbg[x(1:8bit 2:16bit)
	int							OggVorbisFromTheoraFile ;	// Ogg Theora t@C Vorbis f[^QƂ邩ǂ̃tO( TRUE:Theora t@C Vorbis f[^QƂ )
#endif
} ;

// ֐vg^Cv錾-----------------------------------------------------------

// EI֐
extern	int InitializeSoundConvert( void ) ;														// TEhf[^ϊ̏s
extern	int TerminateSoundConvert( void ) ;															// TEhf[^ϊ̏Is

// tH[}bgϊp
extern	int SetupSoundConvert( SOUNDCONV *SoundConv, STREAMDATA *Stream, int DisableReadSoundFunctionMask = 0, int OggVorbisBitDepth = 2, int OggVorbisFromTheoraFile = FALSE ) ;	// ϊ̃ZbgAbv( [] -1:G[ )
//extern	int SetTimeSoundConvert(      SOUNDCONV *SoundConv, int Time ) ;						// ϊ̈ʒuύX( ~bP )
extern	int SetSampleTimeSoundConvert(    SOUNDCONV *SoundConv, int SampleTime ) ;					// ϊ̈ʒuύX( TvP )
extern	int SetupSeekPosSoundConvert(     SOUNDCONV *SoundConv, int SeekPos ) ;						// V[N\̈ʒuZbgĂ(`blׂ̈)
extern	int RunSoundConvert(              SOUNDCONV *SoundConv, void *DestBuffer, int DestSize ) ;	// w̃TCY( [] -1:G[  0ȏ:ϊTCY )
extern	int TerminateSoundConvert(        SOUNDCONV *SoundConv ) ;									// ϊ̌ns
extern	int GetOutSoundFormatInfo(        SOUNDCONV *SoundConv, WAVEFORMATEX *OutWaveFormat ) ;		// ϊ̉`擾( [] -1:G[  0ȏ:ϊ̃TCY )
extern	int GetSoundConvertEndState(      SOUNDCONV *SoundConv ) ;									// ϊIĂ邩ǂ擾( [] TRUE:I  FALSE:܂IĂȂ )
extern	int GetSoundConvertDestSize_Fast( SOUNDCONV *SoundConv ) ;									// ϊ̑}̃f[^TCY𓾂
extern	int SoundConvertFast(             SOUNDCONV *SoundConv, WAVEFORMATEX *FormatP, void **DestBufferP, int *DestSizeP ) ;	// Ȉꊇϊ

#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // __DXSOUNDCONVERT_H__
