// ----------------------------------------------------------------------------
//
//		cwCu@[r[ĐpvO
//
//				Ver 3.12c
//
// ----------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

#include "DxMovie.h"

#ifndef DX_NON_MOVIE

// CN[h----------------------------------------------------------------
#include "DxLib.h"
#include "DxStatic.h"
#include "DxFile.h"
#include "DxBaseFunc.h"
#include "DxMemory.h"
#include "DxSound.h"
#include "DxUseCLib.h"
#include "DxLog.h"
#include "DxSystem.h"
#include "Windows/DxWindow.h"
#include "Windows/DxWinAPI.h"
#include "Windows/DxGuid.h"
#include "Windows/DxFileWin.h"

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N`------------------------------------------------------------------

// [r[XVԊu
#define MOVIEREFRESHWAIT		(17)

// [r[nh̗L`FbN
#define MOVIEHCHK( HAND, MPOINT )		HANDLECHK(       DX_HANDLETYPE_MOVIE, HAND, *( ( HANDLEINFO ** )&MPOINT ) )
#define MOVIEHCHK_ASYNC( HAND, MPOINT )	HANDLECHK_ASYNC( DX_HANDLETYPE_MOVIE, HAND, *( ( HANDLEINFO ** )&MPOINT ) )

#define VFW_E_NOT_FOUND                  ((HRESULT)0x80040216L)

#define MOVIE MovieData

// \̌^錾----------------------------------------------------------------

// f[^錾------------------------------------------------------------------

MOVIEGRAPHMANAGE MovieData ;								// ֘Af[^

// NX錾 -----------------------------------------------------------------

// ֐vg^Cv錾--------------------------------------------------------

#ifndef DX_NON_DSHOW_MOVIE
// [r[t@CI[v  
extern int OpenMovieFunction(
	MOVIEGRAPH * Movie,
	const TCHAR *FileName,
	int *Width,
	int *Height,
	int SurfaceMode,
	int ASyncThread
) ;
#endif

// vOR[h------------------------------------------------------------

// [r[֘ÅǗ̏
extern int InitializeMovieManage( void )
{
	if( MOVIE.InitializeFlag == TRUE )
		return -1 ;

	// nhǗ̏
	InitializeHandleManage( DX_HANDLETYPE_MOVIE, sizeof( MOVIEGRAPH ), MAX_MOVIE_NUM, InitializeMovieHandle, TerminateMovieHandle, DXSTRING( _T( "[r[" ) ) ) ;

	// tOĂ
	MOVIE.InitializeFlag = TRUE ;

	// I
	return 0 ;
}

// [r[֘ÅǗ̌n
extern int TerminateMovieManage( void )
{
	if( MOVIE.InitializeFlag == FALSE )
		return -1 ;

	// nhǗ̌n
	TerminateHandleManage( DX_HANDLETYPE_MOVIE ) ;

	// tO|
	MOVIE.InitializeFlag = FALSE ;

	// I
	return 0 ;
}

#ifndef DX_NON_DSHOW_MOVIE

// OPENMOVIE_GPARAM ̃f[^Zbg
extern void Graphics_Image_InitOpenMovieGParam( OPENMOVIE_GPARAM *GParam )
{
	GParam->RightAlphaFlag = MOVIE.RightAlphaFlag ;
	GParam->A8R8G8B8Flag = MOVIE.A8R8G8B8Flag ;
	GParam->NotUseYUVFormatSurfaceFlag = MOVIE.NotUseYUVFormatSurfaceFlag ;
}

// [r[t@CI[v  
extern int OpenMovieFunction(
	MOVIEGRAPH * Movie,
	const TCHAR *FileName,
	int *Width,
	int *Height,
	int SurfaceMode,
	int ASyncThread
)
{
	TCHAR ErStr[256] ;
	D_IAMMultiMediaStream *pAMStream = NULL;
	HRESULT hr ;

	Movie->NowImage.GraphData = NULL;
	Movie->YUVFlag = FALSE ;
	Movie->OverlayDestX = 0 ;
	Movie->OverlayDestY = 0 ;
	Movie->OverlayDestExRate = 0 ;
	Movie->OverlayDispFlag = 0 ;
	Movie->FirstUpdateFlag = FALSE ;
	_MEMSET( &Movie->OverlaySrcRect, 0, sizeof( RECT ) ) ;
	_MEMSET( &Movie->OverlayDestRect, 0, sizeof( RECT ) ) ;

	// I[o[CgȂꍇ̓tJ[ɂ
	if( SurfaceMode == DX_MOVIESURFACE_OVERLAY  )
	{
		SurfaceMode = DX_MOVIESURFACE_FULLCOLOR ;
	}

	// ʂRQrbgJ[[hŃtJ[[hw肵Ăꍇ̓m[}ɂ
	if( SurfaceMode == DX_MOVIESURFACE_FULLCOLOR && NS_GetColorBitDepth() == 32 ) SurfaceMode = DX_MOVIESURFACE_NORMAL ;

	SurfaceMode = DX_MOVIESURFACE_FULLCOLOR ;

	// OtBbNr_[IuWFNg̍쐬
	if( ( FAILED( WinAPI_CoCreateInstance_ASync(CLSID_FILTERGRAPH, NULL, CLSCTX_INPROC, IID_IGRAPHBUILDER, (void **)&Movie->pGraph, ASyncThread ) ) ) )
	{
		lstrcpy( ErStr, DXSTRING( _T( "CLSID_FilterGraph ̍쐬Ɏs܂\n" ) ) ) ;
		goto ERROR_R ;
	}

	// Create the Texture Renderer object
	Movie->pMovieImage = New_D_CMovieRender( NULL, &hr ) ;
    
    // Get a pointer to the IBaseFilter on the TextureRenderer, add it to graph
    if (FAILED(hr = Movie->pGraph->AddFilter( Movie->pMovieImage, L"MovieRenderer")))
    {
        lstrcpy( ErStr, DXSTRING( _T( "Could not add renderer filter to graph!\n" )) );
        return hr;
    }

	// BasicAudio C^[tFCX𓾂
	if( FAILED( Movie->pGraph->QueryInterface( IID_IBASICAUDIO, ( void ** )&Movie->pBasicAudio ) ) )
	{
		lstrcpy( ErStr, DXSTRING( _T( "BasicAudio C^[tF[X̎擾Ɏs܂\n" ) ) ) ;
		goto ERROR_R ;
	}

	// fBARg[IuWFNg擾
	if( FAILED( Movie->pGraph->QueryInterface( IID_IMEDIACONTROL, ( void ** )&Movie->pMediaControl ) ) )
	{
		lstrcpy( ErStr, DXSTRING( _T( "IID_IMediaControlC^[tFCX̎擾Ɏs܂\n" ) ) ) ;
		goto ERROR_R ;
	}

	// fBAV[LOIuWFNg擾
	if( FAILED( Movie->pGraph->QueryInterface( IID_IMEDIASEEKING, ( void ** )&Movie->pMediaSeeking ) ) )
	{
		lstrcpy( ErStr, DXSTRING( _T( "IID_IMediaSeekingC^[tFCX̎擾Ɏs܂\n" ) ) ) ;
		goto ERROR_R ;
	}

   	// t@Cۑ
#ifdef UNICODE
	lstrcpy( Movie->FileName, FileName ) ;
#else
	// t@CUNICODEɕϊ
	MBCharToWChar( _GET_CODEPAGE(), FileName, ( DXWCHAR * )Movie->FileName, sizeof( Movie->FileName ) / sizeof( wchar_t ) ) ;
#endif

	// fBNg̋؂肪 / ɂȂĂӏ \ ɒu
	{
		wchar_t *wp ;

		for( wp = Movie->FileName; *wp; wp++ )
		{
			if( *wp == L'/' )
			{
				*wp = '\\' ;
			}
		}
	}

	hr = Movie->pGraph->RenderFile( Movie->FileName, NULL ) ;
	if( FAILED( hr ) )
	{
		lstrcpy( ErStr, DXSTRING( _T( "RenderFile faired!\n" )) ) ;

		DWORD_PTR fp ;
		HANDLE FileHandle ;
		void *TempBuffer ;
		size_t CompSize, MoveSize ;
		DWORD WriteSize ;
		size_t FileSize ;
		const DWORD BufferSize = 0x100000 ;

		lstrcpy( ErStr, DXSTRING( _T( "t@C:" ) ) ) ;
		lstrcat( ErStr, FileName ) ;
		lstrcat( ErStr, DXSTRING( _T( " J܂ł\n" ) ) );

		// Ƀe|t@C쐬Ăꍇ́A
		// XɃe|t@C쐬邱Ƃ͂Ȃ
		if( Movie->UseTemporaryFile == TRUE )
			goto ERROR_R ;

		// t@CJȂA[JCuĂ\
#ifdef UNICODE
		fp = FOPEN( Movie->FileName ) ;
#else
		fp = FOPEN( FileName ) ;
#endif
		if( fp == 0 ) goto ERROR_R ;
		
		// Jꍇ̓e|t@Cɏo
		{
			// t@CTCY̎擾
			FSEEK( fp, 0L, SEEK_END ) ;
			FileSize = ( size_t )FTELL( fp ) ;
			FSEEK( fp, 0L, SEEK_SET ) ;

			// ꎞIɃf[^i[obt@m
			TempBuffer = DXALLOC( BufferSize ) ;
			if( TempBuffer == NULL )
			{
				FCLOSE( fp ) ;
				goto ERROR_R ;
			}

			// e|t@C̍쐬
#ifdef UNICODE
			FileHandle = CreateTemporaryFile( Movie->FileName ) ;
#else
			char TempFileNameA[ 512 ] ;
			FileHandle = CreateTemporaryFile( TempFileNameA ) ;
			MBCharToWChar( 932, TempFileNameA, ( DXWCHAR * )Movie->FileName, MAX_PATH ) ;
#endif
			if( FileHandle == NULL )
			{
				FCLOSE( fp ) ;
				DXFREE( TempBuffer ) ;
				goto ERROR_R ;
			}
			Movie->UseTemporaryFile = TRUE ;

			// e|t@CɃf[^o
			CompSize = 0 ;
			while( CompSize < FileSize )
			{
				MoveSize = CompSize - FileSize ;
				if( MoveSize > BufferSize ) MoveSize = BufferSize ;

				FREAD( TempBuffer, MoveSize, 1, fp ) ;
				WriteFile( FileHandle, TempBuffer, ( DWORD )MoveSize, &WriteSize, NULL ) ;

				if( MoveSize != WriteSize ) break ;
				CompSize += MoveSize ;
			}

			// t@CA
			FCLOSE( fp ) ;
			CloseHandle( FileHandle ) ;
			DXFREE( TempBuffer ) ;
		}

		// ߂ăt@CJ
		hr = Movie->pGraph->RenderFile( Movie->FileName, NULL ) ;
		if( FAILED( hr ) )
		{
			// e|t@C폜
			DeleteFileW( Movie->FileName ) ;
			goto ERROR_R ;
		}
	}

	// Pt[̎Ԃ𓾂
	Movie->pMediaSeeking->GetDuration( &Movie->FrameTime ) ;
	if( Movie->FrameTime == 0 )
	{
		Movie->FrameTime = 10000000 / 60 ;
	}

	// IԂ擾
	Movie->pMediaSeeking->GetStopPosition( &Movie->StopTime ) ;

	// 摜C[W̏Zbg
	Movie->NowImage.Width = Movie->pMovieImage->Width ;
	Movie->NowImage.Height = Movie->pMovieImage->Height ;
	Movie->NowImage.Pitch = Movie->pMovieImage->Pitch ;
	Movie->NowImage.GraphData = Movie->pMovieImage->ImageBuffer ;
	Movie->NowImageGraphOutAlloc = TRUE ;
	if( Movie->pMovieImage->ImageType == 0 )
	{
		NS_CreateFullColorData( &Movie->NowImage.ColorData ) ;
	}
	else
	if( Movie->pMovieImage->ImageType == 1 && Movie->A8R8G8B8Flag )
	{
		NS_CreateARGB8ColorData( &Movie->NowImage.ColorData ) ;
	}
	else
	{
		NS_CreateXRGB8ColorData( &Movie->NowImage.ColorData ) ;
	}
	Movie->UseNowImage = &Movie->NowImage ;

	if( Width ) *Width = Movie->pMovieImage->Width ;
	if( Height ) *Height = Movie->pMovieImage->Height ;

	// I
	return 0 ;


ERROR_R:

	// ebnlIuWFNgI
	if( pAMStream					){ pAMStream->Release()					; pAMStream = NULL ; }

	if( Movie->pFilter				){ Movie->pFilter->Release()			; Movie->pFilter = NULL ; }
	if( Movie->pAllocator			){ Movie->pAllocator->Release()			; Movie->pAllocator = NULL ; }

	if( Movie->pGraph				){ Movie->pGraph->Release()				; Movie->pGraph = NULL ; }
	if( Movie->pMediaControl		){ Movie->pMediaControl->Release()		; Movie->pMediaControl = NULL ; }
	if( Movie->pMediaSeeking		){ Movie->pMediaSeeking->Release()		; Movie->pMediaSeeking = NULL ; }
	if( Movie->pBasicAudio			){ Movie->pBasicAudio->Release()		; Movie->pBasicAudio = NULL ; }

	return DXST_ERRORLOG_ADD( ErStr ) ;
}

#endif // DX_NON_DSHOW_MOVIE

// [r[t@CI[v
extern int OpenMovie( const TCHAR *FileName, int *Width, int *Height, int SurfaceMode )
{
	OPENMOVIE_GPARAM GParam ;

	Graphics_Image_InitOpenMovieGParam( &GParam ) ;

	return OpenMovie_UseGParam( &GParam, FileName, Width, Height, SurfaceMode ) ;
}

// [r[nh֐
extern int InitializeMovieHandle( HANDLEINFO * )
{
	// ɉȂ
	return 0 ;
}

// [r[nȟns֐
extern int TerminateMovieHandle( HANDLEINFO *HandleInfo )
{
	MOVIEGRAPH *Movie = ( MOVIEGRAPH * )HandleInfo ;

#ifndef DX_NON_OGGTHEORA
	//  Theora gpĂꍇ͂̊Js
	if( Movie->TheoraFlag )
	{
		if( Movie->TheoraStreamData )
		{
			FCLOSE( Movie->TheoraStreamData ) ;
			Movie->TheoraStreamData = 0 ;
		}

		TheoraDecode_Terminate( Movie->TheoraHandle ) ;
#ifndef DX_NON_SOUND
		NS_DeleteSoundMem( Movie->TheoraVorbisHandle ) ;
		Movie->TheoraVorbisHandle = 0 ;
#endif // DX_NON_SOUND
		Movie->TheoraHandle = 0 ;
		Movie->TheoraFlag = 0 ;
	}
#endif

#ifndef DX_NON_DSHOW_MOVIE
	// e|t@CgpĂꍇ̓e|t@C폜
	if( Movie->UseTemporaryFile == TRUE )
	{
		DeleteFileW( Movie->FileName ) ;
		Movie->UseTemporaryFile = FALSE ;
	}
#endif // DX_NON_DSHOW_MOVIE

	if( Movie->NowImage.GraphData != NULL )
	{
		if( Movie->NowImageGraphOutAlloc == FALSE )
		{
			DXFREE( Movie->NowImage.GraphData ) ;
		}
		Movie->NowImage.GraphData = NULL ;
	}

	// ebnlIuWFNgI
//	if( Movie->pMovieImage )		{ Movie->pMovieImage->Release() ;			Movie->pMovieImage = NULL ; }
//	if( Movie->pFilter )			{ Movie->pFilter->Release() ;				Movie->pFilter = NULL ; }
	if( Movie->RefreshEvent )		{ CloseHandle( Movie->RefreshEvent ) ; 		Movie->RefreshEvent = NULL ; }
#ifndef DX_NON_DSHOW_MOVIE
	if( Movie->pBasicAudio )		{ Movie->pBasicAudio->Release() ; 			Movie->pBasicAudio = NULL ; }
	if( Movie->pMediaSeeking )		{ Movie->pMediaSeeking->Release() ; 		Movie->pMediaSeeking = NULL ; }
	if( Movie->pMediaControl )		{ Movie->pMediaControl->Release(); 			Movie->pMediaControl = NULL ; }
	if( Movie->pGraph )				{ Movie->pGraph->Release(); 				Movie->pGraph = NULL ; }
#endif

	// I
	return 0 ;
}

// OpenMovie ̃O[oϐɃANZXȂo[W
extern int OpenMovie_UseGParam( OPENMOVIE_GPARAM *GParam, const TCHAR *FileName, int *Width, int *Height, int SurfaceMode, int ASyncThread )
{
	int NewHandle ;
	MOVIEGRAPH * Movie ;

	// nh̍쐬
	NewHandle = AddHandle( DX_HANDLETYPE_MOVIE ) ;
	if( NewHandle < 0 )
		return -1 ;

	if( MOVIEHCHK( NewHandle, Movie ) )
		return -1 ;

	// EAt@ƂĈtOZbg
	Movie->RightAlpha = GParam->RightAlphaFlag ;

	// 32bitJ[tH[}bg̓ A8R8G8B8 `ƂĈǂ̃tOZbg
	Movie->A8R8G8B8Flag = GParam->A8R8G8B8Flag ;

	// YUVtH[}bg̃T[tFXgpȂǂ̃tOZbg
	Movie->NotUseYUVFormatSurfaceFlag = GParam->NotUseYUVFormatSurfaceFlag ;

#ifndef DX_NON_OGGTHEORA
	// Ogg Theora ƂăI[v悤ƂĂ݂
	Movie->TheoraStreamData = FOPEN( FileName ) ;
	Movie->TheoraHandle = TheoraDecode_InitializeStream( &StreamFunction, Movie->TheoraStreamData, 10, Movie->NotUseYUVFormatSurfaceFlag, ASyncThread ) ;
	if( Movie->TheoraHandle == 0 )
	{
		FCLOSE( Movie->TheoraStreamData ) ;
		Movie->TheoraStreamData = 0 ;
	}
	if( Movie->TheoraHandle != 0 )
	{
		THEORADECODE_INFO Info ;

		// 𖄂߂
		TheoraDecode_GetInfo( Movie->TheoraHandle, &Info ) ;
		Movie->Width  = Info.Width ;
		Movie->Height = Info.Height ;
		if( Width  ) *Width  = Info.Width ;
		if( Height ) *Height = Info.Height ;
		Movie->TheoraFrameRate = Info.FrameRate ;
		Movie->TheoraTotalPlayTime = _DTOL( 1000.0 / Info.FrameRate * Info.TotalFrame ) ;

#ifndef DX_NON_SOUND
		LOADSOUND_GPARAM GParam ;

		InitLoadSoundGParam( &GParam ) ;

		// J Thera p̃ZbgAbvs

		// TEhĐpɃTEhf[^ƂĂǂݍ
		GParam.CreateSoundDataType = DX_SOUNDDATATYPE_FILE ;
		GParam.OggVorbisFromTheoraFile = TRUE ;
		GParam.DisableReadSoundFunctionMask = ~DX_READSOUNDFUNCTION_OGG ;
		Movie->TheoraVorbisHandle = LoadSoundMemBase_UseGParam( &GParam, FileName, 1, -1, FALSE, ASyncThread ) ;
		Movie->TheoraVorbisTotalTime = NS_GetSoundTotalTime( Movie->TheoraVorbisHandle ) ;

		// [v^Cv̌( قɂ )
		Movie->TheoraLoopType = Movie->TheoraVorbisTotalTime > Movie->TheoraTotalPlayTime ? 1 : 0 ;

#else // DX_NON_SOUND
		// [v^Cv͓f[^킹
		Movie->TheoraLoopType = 0 ;
#endif // DX_NON_SOUND

		// Theora gpĂtO𗧂Ă
		Movie->TheoraFlag = 1 ;

		// gpׂ BASEIMAGE Zbg
		Movie->UseNowImage = ( BASEIMAGE * )TheoraDecode_GetBaseImage( Movie->TheoraHandle ) ;

		// T[tFX[h̓m[}ƂƂ
		Movie->SurfaceMode = DX_MOVIESURFACE_NORMAL ;
	}
	else
#endif
	{
		// I[vłȂ畁ʂ̃[r[ƂĊJĂ݂

#ifndef DX_NON_DSHOW_MOVIE
		// t@C̃I[v
		Movie->UseTemporaryFile = FALSE ;
		if( OpenMovieFunction( Movie, FileName, Width, Height,SurfaceMode, ASyncThread ) == -1 )
#endif
		{
			DXST_ERRORLOG_ADD( _T( "[r[t@CI[vɃG[܂" ) ) ;
			goto ERR ;
		}

		// gpׂ BASEIMAGE Zbg
		Movie->UseNowImage = &Movie->NowImage ;
	}

	// 摜XVꂽtO|
	Movie->NowImageUpdateFlag = FALSE ;

	// ꎞ~tO𗧂Ă
	Movie->SysPauseFlag = 1 ;

	// ĐtO|
	Movie->PlayFlag = FALSE ;

	// Đ^Cv̓obNOEhɂĂ
	Movie->PlayType = DX_PLAYTYPE_BACK ;

	// nhԂ
	return NewHandle ;

ERR :
	CloseMovie( NewHandle ) ;

	// G[I
	return -1 ;
}

// [r[OtBbNI
extern int CloseMovie( int MovieHandle )
{
	return SubHandle( MovieHandle ) ;
}

// [r[̍ĐJn
extern int PlayMovie_( int MovieHandle, int PlayType, int SysPlay )
{
	MOVIEGRAPH * Movie ;

	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

	// PlayType  -1 ̏ꍇ͕ύXȂ
	if( PlayType == -1 ) PlayType = Movie->PlayType ;

	// PlayType  DX_PLAYTYPE_NORMAL w肵ꍇ DX_PLAYTYPE_BACK ɂȂ
	if( PlayType == DX_PLAYTYPE_NORMAL ) PlayType = DX_PLAYTYPE_BACK ;

	// ꎞ~tO|Ă牽Ȃ
	if( Movie->SysPauseFlag == 0 ) return 0 ;

	if( SysPlay == 1 && Movie->PlayFlag == FALSE ) return 0 ;

#ifndef DX_NON_OGGTHEORA
	// Theora gpĂ邩ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
		int CurFrame ;
		THEORADECODE_INFO Info ;

		// ĐJn̎Ԃ擾
		Movie->TheoraPlayTime = NS_GetNowHiPerformanceCount() ;

		// ɍĐς݂̃t[OɍĐƂɂ
		TheoraDecode_GetInfo( Movie->TheoraHandle, &Info ) ;
		CurFrame = TheoraDecode_GetCurrentFrame( Movie->TheoraHandle ) ;
		Movie->TheoraPlayTime -= _DTOL( 1000000.0 / Movie->TheoraFrameRate * CurFrame ) ;

		// Vorbis ̍ĐJn
#ifndef DX_NON_SOUND
//		NS_SetSoundCurrentTime( _DTOL( 1000.0 / Movie->TheoraFrameRate * CurFrame ), Movie->TheoraVorbisHandle ) ; 
		NS_PlaySoundMem( Movie->TheoraVorbisHandle, Movie->TheoraLoopType == 1 ? PlayType : DX_PLAYTYPE_BACK, FALSE ) ;
#endif // DX_NON_SOUND
	}
	else
#endif
#ifndef DX_NON_DSHOW_MOVIE
	{
		// Đ
		Movie->pMediaControl->Run() ;
	}
#else // DX_NON_DSHOW_MOVIE
	{
	}
#endif

	// 摜XVꂽtO|
	Movie->NowImageUpdateFlag = FALSE ;

	// ꎞ~tO|
	Movie->SysPauseFlag = 0 ;

	// Đ^Cvۑ
	Movie->PlayType = PlayType ;

	// ĐtO𗧂Ă
	Movie->PlayFlag = TRUE ;

	// I
	return 0 ;
}

// [r[̍ĐXgbv
extern int PauseMovie( int MovieHandle, int SysPause )
{
	MOVIEGRAPH * Movie ;

	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

	// ꎞ~tOĂȂɂȂ
	if( Movie->SysPauseFlag == 1 ) return 0 ;

#ifndef DX_NON_OGGTHEORA
	// Theora gpĂ邩ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
		// Theora gpĂꍇ

		// Vorbis ̍Đ~
#ifndef DX_NON_SOUND
		NS_StopSoundMem( Movie->TheoraVorbisHandle ) ;
#endif // DX_NON_SOUND

		// ݂̍Đԕ܂Ńt[i߂Ă
		UpdateMovie( MovieHandle ) ;
	}
	else
#endif
#ifndef DX_NON_DSHOW_MOVIE
	{
		if( Movie->pMediaControl == NULL ) return 0 ; 

		// ~
		Movie->pMediaControl->Pause() ;
	}
#else // DX_NON_DSHOW_MOVIE
	{
	}
#endif

	// ꎞ~tO𗧂Ă
	Movie->SysPauseFlag = 1 ;

	// ĐtO|
	if( SysPause == 0 )
	{
		Movie->PlayFlag = FALSE ;
	}

	// I
	return 0 ;
}

// [r[̃t[i߂A߂Ƃ͏oȂ( [r[~ԂŁA Ogg Theora ̂ݗL )
extern int AddMovieFrame( int MovieHandle, unsigned int FrameNum )
{
	MOVIEGRAPH * Movie ;

	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

	// 摜XVꂽtO|
	Movie->NowImageUpdateFlag = FALSE ;

#ifndef DX_NON_OGGTHEORA
	// Ogg Theora ł͂ȂύXłȂ
	if( Movie->TheoraFlag == FALSE )
		return -1 ;

	// ĐύXłȂ
	if( GetMovieState( MovieHandle ) == TRUE )
		return -1 ;

	// ĐʒuύX
	TheoraDecode_IncToFrame( Movie->TheoraHandle, FrameNum ) ;

	// I
	return 0 ;
#else
	return -1 ;
#endif
}

// [r[̍Đʒuݒ肷(~bP)
extern int SeekMovie( int MovieHandle, int Time )
{
	MOVIEGRAPH * Movie ;

	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

	// Đ~߂
	PauseMovie( MovieHandle ) ;

	// 摜XVꂽtO|
	Movie->NowImageUpdateFlag = FALSE ;

#ifndef DX_NON_OGGTHEORA
	// Theora gpĂ邩ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
		int CurFrame ;
		THEORADECODE_INFO Info ;

		// Ro[gʒuύX
		TheoraDecode_SeekToTime( Movie->TheoraHandle, Time * 1000 ) ;

		// ĐJn^CύX
		Movie->TheoraPlayTime = NS_GetNowHiPerformanceCount() ;
		TheoraDecode_GetInfo( Movie->TheoraHandle, &Info ) ;
		CurFrame = TheoraDecode_GetCurrentFrame( Movie->TheoraHandle ) ;
		Movie->TheoraPlayTime -= _DTOL( 1000000.0 / Movie->TheoraFrameRate * CurFrame ) ;
	
		// ĐʒuύX
#ifndef DX_NON_SOUND
		NS_SetSoundCurrentTime( Time, Movie->TheoraVorbisHandle ) ;
#endif // DX_NON_SOUND
	}
	else
#endif
#ifndef DX_NON_DSHOW_MOVIE
	{
		LONGLONG Now, Stop ;

		if( Movie->pMediaSeeking == NULL ) return 0 ;

		Now = ( LONGLONG )Time * 10000 ;
		Stop = 0 ;
		Movie->pMediaSeeking->SetPositions( &Now, D_AM_SEEKING_AbsolutePositioning, &Stop, D_AM_SEEKING_NoPositioning ) ;
	}
#else // DX_NON_DSHOW_MOVIE
	{
	}
#endif

	// I
	return 0 ;
}

// [r[̍ĐԂ𓾂
extern int GetMovieState( int MovieHandle )
{
	MOVIEGRAPH * Movie ;
//	OAFilterState PlayFlag ;
#ifndef DX_NON_DSHOW_MOVIE
	LONGLONG Current ;
#endif

	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

#ifndef DX_NON_OGGTHEORA
	// TheoragpĂ邩ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
/*
#ifndef DX_NON_SOUND
		if( Movie->TheoraVorbisHandle != -1 )
		{
			// TEh~ĂĐ~
			if( NS_CheckSoundMem( Movie->TheoraVorbisHandle ) == 0 )
			{
				// ݂̍Đԕ܂Ńt[i߂Ă
				UpdateMovie( MovieHandle ) ;

				// ꎞ~tO𗧂Ă
				Movie->SysPauseFlag = 1 ;

				// ĐtO|
				Movie->PlayFlag = FALSE ;

				// ꎞ~tO𗧂Ă
				Movie->SysPauseFlag = 1 ;
			}
		}
		else
#endif // DX_NON_SOUND
*/
		{
			return Movie->PlayFlag ;
		}
	}
	else
#endif
#ifndef DX_NON_DSHOW_MOVIE
	{
		D_OAFilterState state ;

		if( Movie->pMediaSeeking == NULL )
			return Movie->PlayFlag ; 

		if( Movie->pMediaControl->GetState( 1000, &state ) != S_OK )
		{
			return Movie->PlayFlag ;
		}

		Movie->pMediaSeeking->GetCurrentPosition( &Current ) ;
		if( ( Movie->PlayType & DX_PLAYTYPE_LOOPBIT ) == 0 && Current >= Movie->StopTime && state == D_State_Stopped )
		{
			Movie->PlayFlag = FALSE ;

			// ꎞ~tO𗧂Ă
			Movie->SysPauseFlag = 1 ;
		}
	}
#else // DX_NON_DSHOW_MOVIE
	{
	}
#endif

//	if( Movie->pMediaControl->GetState( INFINITE, &PlayFlag ) != S_OK ) return -1 ;
//	return PlayFlag == State_Running ? 1 : 0 ;
	return Movie->PlayFlag ;
}

// [r[̃{[Zbg(0`10000)
extern int SetMovieVolume( int Volume, int MovieHandle )
{
	MOVIEGRAPH * Movie ;

	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

#ifndef DX_NON_OGGTHEORA
	// Theora gpĂ邩ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
		// Vorbis TEh̉ʂZbg
#ifndef DX_NON_SOUND
		NS_SetVolumeSoundMem( Volume, Movie->TheoraVorbisHandle ) ;
#endif // DX_NON_SOUND
	}
	else
#endif
#ifndef DX_NON_DSHOW_MOVIE
	{
		if( Movie->pBasicAudio == NULL ) return 0 ; 

		// ʃZbg
		if( Volume > 10000 ) Volume = 10000 ;
		if( Volume < 0 ) Volume = 0 ;
		Movie->pBasicAudio->put_Volume( -10000 + Volume ) ;
	}
#else // DX_NON_DSHOW_MOVIE
	{
	}
#endif

	// I
	return 0 ;
}

// [r[̊{C[Wf[^擾
extern BASEIMAGE *GetMovieBaseImage( int MovieHandle, int *ImageUpdateFlag )
{
	MOVIEGRAPH * Movie ;

	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return NULL ;

#ifndef DX_NON_OGGTHEORA
	// Theora gpĂ邩ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
		// [r[̃t[XV
		UpdateMovie( MovieHandle ) ;

		// NowImage ̓eXVꂽǂ̃tO
		if( ImageUpdateFlag != NULL )
		{
			*ImageUpdateFlag = Movie->NowImageUpdateFlag ;
		}
		Movie->NowImageUpdateFlag = FALSE ;

		// Theora ̃C[WԂ
		return ( BASEIMAGE * )TheoraDecode_GetBaseImage( Movie->TheoraHandle ) ;
	}
	else
#endif
#ifndef DX_NON_DSHOW_MOVIE
	{
		// gpĂȂꍇ

		// [r[̃t[XV
		if( GetMovieState( MovieHandle ) == FALSE )
		{
			int Time ;

			Time = TellMovie( MovieHandle ) ;
			PlayMovie_( MovieHandle ) ;
			UpdateMovie( MovieHandle, TRUE ) ;
			PauseMovie( MovieHandle ) ;
			SeekMovie( MovieHandle, Time ) ;
		}
		else
		{
			UpdateMovie( MovieHandle ) ;
		}

		// NowImage ̓eXVꂽǂ̃tO
		if( ImageUpdateFlag != NULL )
		{
			*ImageUpdateFlag = Movie->NowImageUpdateFlag ;
		}
		Movie->NowImageUpdateFlag = FALSE ;

		return &Movie->NowImage ;
	}
#else // DX_NON_DSHOW_MOVIE
	return NULL ;
#endif
}

// [r[̑t[𓾂( Ogg Theora ł̂ݗL )
extern int GetMovieTotalFrame( int MovieHandle )
{
	MOVIEGRAPH * Movie ;

	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

#ifndef DX_NON_OGGTHEORA
	THEORADECODE_INFO info ;

	// Ogg Theora ł͂ȂύXłȂ
	if( Movie->TheoraFlag == FALSE )
		return -1 ;

	// ̎擾
	TheoraDecode_GetInfo( Movie->TheoraHandle, &info ) ;

	// t[Ԃ
	return info.TotalFrame ;
#else
	return -1 ;
#endif
}

// [r[̍Đʒu擾(~bP)
extern int TellMovie( int MovieHandle )
{
	MOVIEGRAPH * Movie ;
#ifndef DX_NON_DSHOW_MOVIE
	D_STREAM_TIME NowTime ;
#endif
	
	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

#ifndef DX_NON_OGGTHEORA
	// Theora gpĂ邩ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
		THEORADECODE_INFO Info ;

		TheoraDecode_GetInfo( Movie->TheoraHandle, &Info ) ;

		// t[XV
		UpdateMovie( MovieHandle ) ;

		// t[ĐԂo
		return _DTOL( TheoraDecode_GetCurrentFrame( Movie->TheoraHandle ) * 1000 / Movie->TheoraFrameRate ) ;
	}
	else
#endif
#ifndef DX_NON_DSHOW_MOVIE
	{
		if( Movie->pMediaSeeking == NULL ) return 0 ;

		// Ԏ擾
		if( Movie->pMediaSeeking->GetCurrentPosition( &NowTime ) != S_OK ) return -1 ;

		// ԂԂ
		return _DTOL( (double)NowTime / 10000 ) ;
	}
#else // DX_NON_DSHOW_MOVIE
	return -1 ;
#endif
}
 
// [r[̍Đʒu擾(t[P)
extern int TellMovieToFrame( int MovieHandle )
{
	MOVIEGRAPH * Movie ;
#ifndef DX_NON_DSHOW_MOVIE
	D_STREAM_TIME NowTime ;
#endif
	
	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

#ifndef DX_NON_OGGTHEORA
	// Theora ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
		THEORADECODE_INFO Info ;

		TheoraDecode_GetInfo( Movie->TheoraHandle, &Info ) ;

		// t[XV
		UpdateMovie( MovieHandle ) ;

		// ݂̃t[Ԃ
		return TheoraDecode_GetCurrentFrame( Movie->TheoraHandle ) ;
	}
	else
#endif
#ifndef DX_NON_DSHOW_MOVIE
	{
		if( Movie->pMediaSeeking == NULL ) return 0 ;

		// Ԏ擾
		if( Movie->pMediaSeeking->GetCurrentPosition( &NowTime ) != S_OK ) return -1 ;

		// ԂԂ
		return _DTOL( (double)NowTime / Movie->FrameTime ) ;
	}
#else // DX_NON_DSHOW_MOVIE
	return -1 ;
#endif
}

// [r[̍Đʒuݒ肷(t[P)
extern int SeekMovieToFrame( int MovieHandle, int Frame )
{
	MOVIEGRAPH * Movie ;
//	D_OAFilterState State ;
	
	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

	// 摜XVꂽtO|
	Movie->NowImageUpdateFlag = FALSE ;

#ifndef DX_NON_OGGTHEORA
	// Theora ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
		int CurFrame ;
		THEORADECODE_INFO Info ;

		// Ro[gʒuύX
		TheoraDecode_SeekToFrame( Movie->TheoraHandle, Frame ) ;

		// ĐJn^CύX
		Movie->TheoraPlayTime = NS_GetNowHiPerformanceCount() ;
		TheoraDecode_GetInfo( Movie->TheoraHandle, &Info ) ;
		CurFrame = TheoraDecode_GetCurrentFrame( Movie->TheoraHandle ) ;
		Movie->TheoraPlayTime -= _DTOL( 1000000.0 / Movie->TheoraFrameRate * CurFrame ) ;
	
		// ĐʒuύX
#ifndef DX_NON_SOUND
		NS_SetSoundCurrentTime( _DTOL( Frame * 1000 / Movie->TheoraFrameRate ), Movie->TheoraVorbisHandle ) ;
#endif // DX_NON_SOUND
	}
	else
#endif
#ifndef DX_NON_DSHOW_MOVIE
	{
		LONGLONG Now, Stop ;

		if( Movie->pMediaSeeking == NULL ) return 0 ;

		Now = ( D_STREAM_TIME )_DTOL64( (double)Frame * Movie->FrameTime ) ;
		Stop = 0 ;
		Movie->pMediaSeeking->SetPositions( &Now, D_AM_SEEKING_AbsolutePositioning, &Stop, D_AM_SEEKING_NoPositioning ) ;
	}
#else  // DX_NON_DSHOW_MOVIE
	{
	}
#endif

	// I
	return 0 ;
}

// [r[̂Pt[̎Ԃ𓾂
extern LONGLONG GetOneFrameTimeMovie( int MovieHandle )
{
	MOVIEGRAPH * Movie ;
	
	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

#ifndef DX_NON_OGGTHEORA
	// Theora ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
		THEORADECODE_INFO Info ;

		TheoraDecode_GetInfo( Movie->TheoraHandle, &Info ) ;
		return _DTOL( 1000000 / Movie->TheoraFrameRate ) ;
	}
	else
#endif
#ifndef DX_NON_DSHOW_MOVIE
	{
		return Movie->FrameTime ;
	}
#else // DX_NON_DSHOW_MOVIE
	return -1 ;
#endif
}

// [r[OtBbÑf[^擾
extern MOVIEGRAPH * GetMovieData( int MovieHandle )
{
	MOVIEGRAPH * Movie ;
	
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return NULL ;

	return Movie ;
}


// [r[ŎgpĂT[tFX̉s
extern int ReleaseMovieSurface( int MovieHandle )
{
	MOVIEGRAPH * Movie ;
	
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

#ifndef DX_NON_OGGTHEORA
	if( Movie->TheoraFlag )
	{
		TheoraDecode_SurfaceTerminate( Movie->TheoraHandle ) ;
	}
	else
#endif
	{
	}

	// I
	return 0 ;
}

// [r[̍XVs
extern int UpdateMovie( int MovieHandle, int /*AlwaysFlag*/ )
{
	MOVIEGRAPH * Movie ;
//	LONGLONG NowFrame, OldFrame ;
	
	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

#ifndef DX_NON_OGGTHEORA
	// Theora gpĂ邩ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
		// Theora gpĂꍇ
		int NowFrame, CurFrame, AddFrame ;
		LONGLONG NowTime ;
		THEORADECODE_INFO Info ;

		// Theora ̏擾
		TheoraDecode_GetInfo( Movie->TheoraHandle, &Info ) ;

		// ̍Đԕt[i߂
		if( Movie->SysPauseFlag == 0 )
		{
			// ĐԂ͉Lȏꍇ͉擾
#ifndef DX_NON_SOUND
			if( Movie->TheoraVorbisHandle != -1 && NS_CheckSoundMem( Movie->TheoraVorbisHandle ) == 1 )
			{
				NowTime = NS_GetSoundCurrentTime( Movie->TheoraVorbisHandle ) * 1000 ;
				NowFrame = _DTOL( ( double )( NowTime * Movie->TheoraFrameRate ) / 1000000 ) ;

				// 特擾ꍇ́Af̍őt[𒴂Ă܂ꍇ͌݃t[f̍őt[ɂ
				if( NowFrame >= Info.TotalFrame )
				{
					NowFrame = Info.TotalFrame - 1 ;
				}
			}
			else
#endif // DX_NON_SOUND
			{
				NowTime = NS_GetNowHiPerformanceCount() ;
				NowFrame = _DTOL( ( double )( ( NowTime - Movie->TheoraPlayTime ) * Movie->TheoraFrameRate ) / 1000000 ) ;

				// [vw肪邩ǂőt[𒴂Ăꍇ̏𕪊򂷂
				if( Info.TotalFrame <= NowFrame )
				{
					if( Movie->PlayType & DX_PLAYTYPE_LOOPBIT )
					{
						// [vꍇ͑t[Ŋ]o
						NowFrame %= Info.TotalFrame ;
					}
					else
					{
						// [vȂꍇ͍ŏIt[Ŏ~܂
						NowFrame = Info.TotalFrame - 1 ;
					}
				}
			}

			// [r[̍Đt[擾
			CurFrame = TheoraDecode_GetCurrentFrame( Movie->TheoraHandle ) ;

			// ]̃t[݃obt@Ɋi[Ăt[ƈႤꍇ̓obt@XV
			if( CurFrame != NowFrame )
			{
				Movie->NowImageUpdateFlag = TRUE ;

				// Zt[Zo
				if( NowFrame < CurFrame )
				{
					// [vꍇ
					AddFrame = Info.TotalFrame - CurFrame + NowFrame ;

#ifndef DX_NON_SOUND
					// [vꍇŁAĐ^Cv̏ꍇ̓TEhēxĐJn
					if( Movie->TheoraLoopType == 0 )
					{
						NS_PlaySoundMem( Movie->TheoraVorbisHandle, DX_PLAYTYPE_BACK ) ;
					}
#endif // DX_NON_SOUND
				}
				else
				{
					AddFrame = NowFrame - CurFrame ;
				}

				// t[i߂
				TheoraDecode_IncToFrame( Movie->TheoraHandle, AddFrame ) ;

				// ŏIXVԂۑ
				Movie->RefreshTime = ( int )( NowTime / 1000 ) ;
			}
			else
			{
				// ]̃t[t[I[ɒBĂĊ[vwłTEhꍇ͂ōĐI
				if( NowFrame == Info.TotalFrame - 1 &&
					( Movie->PlayType & DX_PLAYTYPE_LOOPBIT ) == 0
#ifndef DX_NON_SOUND
					&& ( Movie->TheoraVorbisHandle == -1 || NS_CheckSoundMem( Movie->TheoraVorbisHandle ) != 1 )
#endif // DX_NON_SOUND
					)
				{
					Movie->PlayFlag = FALSE ;

					// ꎞ~tO𗧂Ă
					Movie->SysPauseFlag = 1 ;
				}
			}
		}

		// C[W̍\z
		if( Movie->UpdateFunction )
		{
			Movie->UpdateFunction( Movie, Movie->UpdateFunctionData ) ;

			// ŏ̍XVsꂽtOZbg
			Movie->FirstUpdateFlag = TRUE ;
		}
	}
	else
#endif
#ifndef DX_NON_DSHOW_MOVIE
	{
		LONGLONG Now, Stop ;

		if( Movie->pMovieImage->NewImageSet )
		{
			Movie->NowImageUpdateFlag = TRUE ;

			Movie->pMovieImage->NewImageSet = 0 ;
			if( Movie->UpdateFunction )
			{
				Movie->NowImage.Width = Movie->pMovieImage->Width ;
				Movie->NowImage.Height = Movie->pMovieImage->Height ;
				Movie->NowImage.Pitch = Movie->pMovieImage->Pitch ;
				Movie->NowImage.GraphData = Movie->pMovieImage->ImageBuffer ;
				Movie->NowImageGraphOutAlloc = TRUE ;
				if( Movie->pMovieImage->ImageType == 0 )
				{
					NS_CreateFullColorData( &Movie->NowImage.ColorData ) ;
				}
				else
				if( Movie->pMovieImage->ImageType == 1 && Movie->A8R8G8B8Flag )
				{
					NS_CreateARGB8ColorData( &Movie->NowImage.ColorData ) ;
				}
				else
				{
					NS_CreateXRGB8ColorData( &Movie->NowImage.ColorData ) ;
				}
				Movie->UseNowImage = &Movie->NowImage ;
				Movie->UpdateFunction( Movie, Movie->UpdateFunctionData ) ;
			}
		}

		if( Movie->pMediaSeeking && Movie->pMediaControl )
		{
			Movie->pMediaSeeking->GetCurrentPosition( &Now ) ;
			if( Now >= Movie->StopTime )
			{
				if( Movie->PlayType & DX_PLAYTYPE_LOOPBIT )
				{
					Now = 0 ;
					Stop = 0 ;
					Movie->pMediaSeeking->SetPositions( &Now, D_AM_SEEKING_AbsolutePositioning, &Stop, D_AM_SEEKING_NoPositioning ) ;
					Movie->pMediaControl->Run() ;
				}
				else
				{
					// ~
					Movie->pMediaControl->Pause() ;

					Movie->PlayFlag = FALSE ;

					// ꎞ~tO𗧂Ă
					Movie->SysPauseFlag = 1 ;
				}
			}
		}
	}
#else // DX_NON_DSHOW_MOVIE
	{
	}
#endif

	// I
	return 0 ;
}

// [r[̍XVɌĂяoR[obN֐o^
extern int SetCallbackMovie( int MovieHandle, void ( *Callback )( MOVIEGRAPH *Movie, void *Data ), void *Data )
{
	MOVIEGRAPH *Movie ;

	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

	// AhXZbg
	Movie->UpdateFunction = Callback ;
	Movie->UpdateFunctionData = Data ;

	// I
	return 0 ;
}

// [r[̍ĐԂ~
extern int DisableMovieAll( void )
{
	MOVIEGRAPH *Movie ;
	int i ;

	if( MOVIE.InitializeFlag == FALSE )
		return -1 ;

	// ׂẴ[r[ɂďs
	for( i = HandleManageArray[ DX_HANDLETYPE_MOVIE ].AreaMin ; i <= HandleManageArray[ DX_HANDLETYPE_MOVIE ].AreaMax ; i ++ )
	{
		Movie = ( MOVIEGRAPH * )HandleManageArray[ DX_HANDLETYPE_MOVIE ].Handle[ i ] ;
		if( Movie == NULL ) continue ;

#ifndef DX_NON_OGGTHEORA
		// Theora gpĂ邩ǂŏ𕪊
		if( Movie->TheoraFlag )
		{
			// Ȃ
/*
			// ꎞ~tO|Ă珈
			if( Movie->SysPauseFlag == 0 )
			{
				// Vorbis ̍Đ~
				NS_StopSoundMem( Movie->TheoraVorbisHandle ) ;

				// ݂̍Đԕ܂Ńt[i߂Ă
				{
					int NowFrame, CurFrame ;
					LONGLONG NowTime ;
					THEORADECODE_INFO Info ;

					// Theora ̏擾
					TheoraDecode_GetInfo( Movie->TheoraHandle, &Info ) ;

					// ̍Đԕt[i߂
					NowTime = NS_GetNowHiPerformanceCount() ;
					NowFrame = _DTOL( ( double )( ( NowTime - Movie->TheoraPlayTime ) * Movie->TheoraFrameRate ) / 1000000 ) ;
					CurFrame = TheoraDecode_GetCurrentFrame( Movie->TheoraHandle ) ;
					if( CurFrame != NowFrame )
					{
						if( NowFrame < CurFrame )
						{
							TheoraDecode_SeekToFrame( Movie->TheoraHandle, NowFrame ) ;
						}
						else
						{
							TheoraDecode_IncToFrame( Movie->TheoraHandle, NowFrame - CurFrame ) ;
						}
					}

					// C[W̍\z
					TheoraDecode_SetupImage( Movie->TheoraHandle ) ;
				}

				// ꎞ~tO𗧂Ă
				Movie->SysPauseFlag = 1 ;
			}
*/		}
		else
#endif
#ifndef DX_NON_DSHOW_MOVIE
		{
/*			if( Movie )
			{
				// ݂̍ĐԂۑ
				Movie->pMediaSeeking->GetCurrentPosition( &Movie->BackUpTime ) ;

				// ebnlIuWFNgI

				if( Movie->pMediaControl		){ Movie->pMediaControl->Release() ;		Movie->pMediaControl = NULL ;		}
				if( Movie->pMediaSeeking		){ Movie->pMediaSeeking->Release() ;		Movie->pMediaSeeking = NULL ;		}
				if( Movie->pBasicAudio			){ Movie->pBasicAudio->Release() ;			Movie->pBasicAudio = NULL ;			}
				if( Movie->pMovieImage			){ Movie->pMovieImage->Release() ;			Movie->pMovieImage = NULL ;			}
				if( Movie->pFilter				){ Movie->pFilter->Release() ;				Movie->pFilter = NULL ;				}
				if( Movie->pGraph				){ Movie->pGraph->Release() ;				Movie->pGraph = NULL ;				}
			}
*/		}
#else  // DX_NON_DSHOW_MOVIE
		{
		}
#endif
	}

	// I
	return 0 ;
}


// [r[̍ĐԂ𕜌
extern int RestoreMovieAll( void )
{
	MOVIEGRAPH *Movie ;
	int i ;

	if( MOVIE.InitializeFlag == FALSE )
		return -1 ;

	// ׂẴ[r[ɂďs
	for( i = HandleManageArray[ DX_HANDLETYPE_MOVIE ].AreaMin ; i <= HandleManageArray[ DX_HANDLETYPE_MOVIE ].AreaMax ; i ++ )
	{
		Movie = ( MOVIEGRAPH * )HandleManageArray[ DX_HANDLETYPE_MOVIE ].Handle[ i ] ;
		if( Movie == NULL ) continue ;

#ifndef DX_NON_OGGTHEORA
		// Theora ǂŏ𕪊
		if( Movie->TheoraFlag )
		{
			// Ȃ
/*
			// ĐtOĂꍇ̂ݏ
			if( Movie->PlayFlag )
			{
				// ꎞ~tOĂ珈
				if( Movie->SysPauseFlag == 1 )
				{
					int CurFrame ;
					THEORADECODE_INFO Info ;

					// ĐJn̎Ԃ擾
					Movie->TheoraPlayTime = NS_GetNowHiPerformanceCount() ;

					// ɍĐς݂̃t[OɍĐƂɂ
					TheoraDecode_GetInfo( Movie->TheoraHandle, &Info ) ;
					CurFrame = TheoraDecode_GetCurrentFrame( Movie->TheoraHandle ) ;
					Movie->TheoraPlayTime -= _DTOL( 1000000.0 / Movie->TheoraFrameRate * CurFrame ) ;

					// Vorbis ̍ĐJn
					NS_PlaySoundMem( Movie->TheoraVorbisHandle, DX_PLAYTYPE_BACK, FALSE ) ;

					// ꎞ~tO|
					Movie->SysPauseFlag = 0 ;
				}
			}
*/
		}
		else
#endif
#ifndef DX_NON_DSHOW_MOVIE
		{
/*			if( Movie )
			{
				LONGLONG Now, Stop ;

				// ăI[vs
				if( OpenMovieFunction( Movie, Movie->FileName, NULL, NULL, Movie->SurfaceMode ) == -1 )
					return -1 ;

				// 폜O̍Đ|Cgɐݒ
				Now = Movie->BackUpTime ;
				Stop = 0 ;
				Movie->pMediaSeeking->SetPositions( &Now, D_AM_SEEKING_AbsolutePositioning, &Stop, D_AM_SEEKING_NoPositioning ) ;

				// ĐtOĂꍇ͍Đ
				if( Movie->SysPauseFlag == 0 )
				{
					Movie->pMediaControl->Run() ;
				}
			}
*/		}
#else // DX_NON_DSHOW_MOVIE
		{
		}
#endif
	}

	// I
	return 0 ;

}

// ׂẴ[r[OtBbNX^[g
extern int PlayMovieAll( void )
{
	MOVIEGRAPH *Movie ;
	int i ;

	if( MOVIE.InitializeFlag == FALSE )
		return -1 ;

	for( i = HandleManageArray[ DX_HANDLETYPE_MOVIE ].AreaMin ; i <= HandleManageArray[ DX_HANDLETYPE_MOVIE ].AreaMax ; i ++ )
	{
		Movie = ( MOVIEGRAPH * )HandleManageArray[ DX_HANDLETYPE_MOVIE ].Handle[ i ] ;
		if( Movie == NULL ) continue ; 

		PlayMovie_( Movie->HandleInfo.Handle, -1, 1 ) ;
	}

	// I
	return 0 ;
}

// ׂẴ[r[OtBbNXgbv
extern int PauseMovieAll( void )
{
	MOVIEGRAPH *Movie ;
	int i ;

	if( MOVIE.InitializeFlag == FALSE )
		return -1 ;

	for( i = HandleManageArray[ DX_HANDLETYPE_MOVIE ].AreaMin ; i <= HandleManageArray[ DX_HANDLETYPE_MOVIE ].AreaMax ; i ++ )
	{
		Movie = ( MOVIEGRAPH * )HandleManageArray[ DX_HANDLETYPE_MOVIE ].Handle[ i ] ;
		if( Movie == NULL ) continue ; 

		PauseMovie( Movie->HandleInfo.Handle, 1 ) ;
	}

	// I
	return 0 ;
}

// t@C̉EAt@ƂĈǂZbg( TRUE:At@ƂĈ )
extern int NS_SetMovieRightImageAlphaFlag( int Flag )
{
	MOVIE.RightAlphaFlag = Flag;
	return TRUE;
}

// ǂݍޓt@C32bitJ[ꍇAA8R8G8B8 `ƂĈǂZbgA
// 32bitJ[ł͂Ȃt@Cɑ΂Ă͖( Flag  TRUE:A8R8G8B8ƂĈ  FALSE:X8R8G8B8ƂĈ( ftHg ) )
extern int NS_SetMovieColorA8R8G8B8Flag( int Flag )
{
	MOVIE.A8R8G8B8Flag = Flag;
	return TRUE;
}

// xtutH[}bg̃T[tFXgpłꍇ͂xtutH[}bg̃T[tFXgp邩ǂݒ肷( TRUE:gp( ftHg ) FALSE:qfatH[}bg̃T[tFXgp )
extern int NS_SetMovieUseYUVFormatSurfaceFlag( int Flag )
{
	MOVIE.NotUseYUVFormatSurfaceFlag = Flag ? FALSE : TRUE ;
	return TRUE;
}


#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif
